<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyspottedunipd.fb.models</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a href="https://github.com/sirfoga/spotted-unipd">PySpottedUnipd</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyspottedunipd-module.html">Package&nbsp;pyspottedunipd</a> ::
        <a href="pyspottedunipd.fb-module.html">Package&nbsp;fb</a> ::
        Module&nbsp;models
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
        <tr><td align="right"><span class="options"
            >[<a href="frames.html" target="_top">frames</a
            >]&nbsp;|&nbsp;<a href="pyspottedunipd.fb.models-pysrc.html"
            target="_top">no&nbsp;frames</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<h1 class="epydoc">Source Code for <a href="pyspottedunipd.fb.models-module.html">Module pyspottedunipd.fb.models</a></h1>
<pre class="py-src">
<a name="L1"></a><tt class="py-lineno">  1</tt>  <tt class="py-line"><tt class="py-comment"># !/usr/bin/python3</tt> </tt>
<a name="L2"></a><tt class="py-lineno">  2</tt>  <tt class="py-line"><tt class="py-comment"># coding: utf-8</tt> </tt>
<a name="L3"></a><tt class="py-lineno">  3</tt>  <tt class="py-line"> </tt>
<a name="L4"></a><tt class="py-lineno">  4</tt>  <tt class="py-line"><tt class="py-comment"># Copyright 2017 Stefano Fogarollo</tt> </tt>
<a name="L5"></a><tt class="py-lineno">  5</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L6"></a><tt class="py-lineno">  6</tt>  <tt class="py-line"><tt class="py-comment"># Licensed under the Apache License, Version 2.0 (the "License");</tt> </tt>
<a name="L7"></a><tt class="py-lineno">  7</tt>  <tt class="py-line"><tt class="py-comment"># you may not use this file except in compliance with the License.</tt> </tt>
<a name="L8"></a><tt class="py-lineno">  8</tt>  <tt class="py-line"><tt class="py-comment"># You may obtain a copy of the License at</tt> </tt>
<a name="L9"></a><tt class="py-lineno">  9</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L10"></a><tt class="py-lineno"> 10</tt>  <tt class="py-line"><tt class="py-comment"># http://www.apache.org/licenses/LICENSE-2.0</tt> </tt>
<a name="L11"></a><tt class="py-lineno"> 11</tt>  <tt class="py-line"><tt class="py-comment">#</tt> </tt>
<a name="L12"></a><tt class="py-lineno"> 12</tt>  <tt class="py-line"><tt class="py-comment"># Unless required by applicable law or agreed to in writing, software</tt> </tt>
<a name="L13"></a><tt class="py-lineno"> 13</tt>  <tt class="py-line"><tt class="py-comment"># distributed under the License is distributed on an "AS IS" BASIS,</tt> </tt>
<a name="L14"></a><tt class="py-lineno"> 14</tt>  <tt class="py-line"><tt class="py-comment"># WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</tt> </tt>
<a name="L15"></a><tt class="py-lineno"> 15</tt>  <tt class="py-line"><tt class="py-comment"># See the License for the specific language governing permissions and</tt> </tt>
<a name="L16"></a><tt class="py-lineno"> 16</tt>  <tt class="py-line"><tt class="py-comment"># limitations under the License.</tt> </tt>
<a name="L17"></a><tt class="py-lineno"> 17</tt>  <tt class="py-line"> </tt>
<a name="L18"></a><tt class="py-lineno"> 18</tt>  <tt class="py-line"> </tt>
<a name="L19"></a><tt class="py-lineno"> 19</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">datetime</tt> </tt>
<a name="L20"></a><tt class="py-lineno"> 20</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">json</tt> </tt>
<a name="L21"></a><tt class="py-lineno"> 21</tt>  <tt class="py-line"> </tt>
<a name="L22"></a><tt class="py-lineno"> 22</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">facebook</tt> </tt>
<a name="L23"></a><tt class="py-lineno"> 23</tt>  <tt class="py-line"><tt class="py-keyword">import</tt> <tt class="py-name">requests</tt> </tt>
<a name="L24"></a><tt class="py-lineno"> 24</tt>  <tt class="py-line"> </tt>
<a name="L25"></a><tt class="py-lineno"> 25</tt>  <tt class="py-line"><tt class="py-keyword">from</tt> <tt id="link-0" class="py-name" targets="Package pyspottedunipd=pyspottedunipd-module.html"><a title="pyspottedunipd" class="py-name" href="#" onclick="return doclink('link-0', 'pyspottedunipd', 'link-0');">pyspottedunipd</a></tt> <tt class="py-keyword">import</tt> <tt id="link-1" class="py-name" targets="Module pyspottedunipd.utils=pyspottedunipd.utils-module.html"><a title="pyspottedunipd.utils" class="py-name" href="#" onclick="return doclink('link-1', 'utils', 'link-1');">utils</a></tt> </tt>
<a name="FacebookGraphApi"></a><div id="FacebookGraphApi-def"><a name="L26"></a><tt class="py-lineno"> 26</tt>  <tt class="py-line"> </tt>
<a name="L27"></a><tt class="py-lineno"> 27</tt>  <tt class="py-line"> </tt>
<a name="L28"></a><tt class="py-lineno"> 28</tt> <a class="py-toggle" href="#" id="FacebookGraphApi-toggle" onclick="return toggle('FacebookGraphApi');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookGraphApi-class.html">FacebookGraphApi</a><tt class="py-op">(</tt><tt class="py-base-class">object</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookGraphApi-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="FacebookGraphApi-expanded"><a name="L29"></a><tt class="py-lineno"> 29</tt>  <tt class="py-line">    <tt class="py-docstring">""" The official Facebook graph API driver (parser, scraper ...) """</tt> </tt>
<a name="L30"></a><tt class="py-lineno"> 30</tt>  <tt class="py-line"> </tt>
<a name="FacebookGraphApi.__init__"></a><div id="FacebookGraphApi.__init__-def"><a name="L31"></a><tt class="py-lineno"> 31</tt> <a class="py-toggle" href="#" id="FacebookGraphApi.__init__-toggle" onclick="return toggle('FacebookGraphApi.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookGraphApi-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">token</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookGraphApi.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookGraphApi.__init__-expanded"><a name="L32"></a><tt class="py-lineno"> 32</tt>  <tt class="py-line">        <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-2" class="py-name" targets="Method pyspottedunipd.analysis.models.FacebookPostsDataFilter.__init__()=pyspottedunipd.analysis.models.FacebookPostsDataFilter-class.html#__init__,Method pyspottedunipd.analysis.models.MLAnalysis.__init__()=pyspottedunipd.analysis.models.MLAnalysis-class.html#__init__,Method pyspottedunipd.analysis.models.StatsAnalysis.__init__()=pyspottedunipd.analysis.models.StatsAnalysis-class.html#__init__,Method pyspottedunipd.analysis.models.TimeAnalysis.__init__()=pyspottedunipd.analysis.models.TimeAnalysis-class.html#__init__,Method pyspottedunipd.fb.models.FacebookBot.__init__()=pyspottedunipd.fb.models.FacebookBot-class.html#__init__,Method pyspottedunipd.fb.models.FacebookGraphApi.__init__()=pyspottedunipd.fb.models.FacebookGraphApi-class.html#__init__,Method pyspottedunipd.fb.models.FacebookPost.__init__()=pyspottedunipd.fb.models.FacebookPost-class.html#__init__,Method pyspottedunipd.ngrams.models.Cup.__init__()=pyspottedunipd.ngrams.models.Cup-class.html#__init__,Method pyspottedunipd.ngrams.models.Markov.__init__()=pyspottedunipd.ngrams.models.Markov-class.html#__init__,Method pyspottedunipd.ngrams.models.NGram.__init__()=pyspottedunipd.ngrams.models.NGram-class.html#__init__"><a title="pyspottedunipd.analysis.models.FacebookPostsDataFilter.__init__
pyspottedunipd.analysis.models.MLAnalysis.__init__
pyspottedunipd.analysis.models.StatsAnalysis.__init__
pyspottedunipd.analysis.models.TimeAnalysis.__init__
pyspottedunipd.fb.models.FacebookBot.__init__
pyspottedunipd.fb.models.FacebookGraphApi.__init__
pyspottedunipd.fb.models.FacebookPost.__init__
pyspottedunipd.ngrams.models.Cup.__init__
pyspottedunipd.ngrams.models.Markov.__init__
pyspottedunipd.ngrams.models.NGram.__init__" class="py-name" href="#" onclick="return doclink('link-2', '__init__', 'link-2');">__init__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">)</tt> </tt>
<a name="L33"></a><tt class="py-lineno"> 33</tt>  <tt class="py-line"> </tt>
<a name="L34"></a><tt class="py-lineno"> 34</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">token</tt> <tt class="py-op">=</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">token</tt><tt class="py-op">)</tt> </tt>
</div><a name="L35"></a><tt class="py-lineno"> 35</tt>  <tt class="py-line"> </tt>
<a name="L36"></a><tt class="py-lineno"> 36</tt>  <tt class="py-line">    <tt class="py-decorator">@</tt><tt class="py-decorator">staticmethod</tt> </tt>
<a name="FacebookGraphApi.get_api_url"></a><div id="FacebookGraphApi.get_api_url-def"><a name="L37"></a><tt class="py-lineno"> 37</tt> <a class="py-toggle" href="#" id="FacebookGraphApi.get_api_url-toggle" onclick="return toggle('FacebookGraphApi.get_api_url');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookGraphApi-class.html#get_api_url">get_api_url</a><tt class="py-op">(</tt><tt class="py-param">version</tt><tt class="py-op">=</tt><tt class="py-string">"2.8"</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookGraphApi.get_api_url-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookGraphApi.get_api_url-expanded"><a name="L38"></a><tt class="py-lineno"> 38</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L39"></a><tt class="py-lineno"> 39</tt>  <tt class="py-line"><tt class="py-docstring">        :param version: str</tt> </tt>
<a name="L40"></a><tt class="py-lineno"> 40</tt>  <tt class="py-line"><tt class="py-docstring">            Version of API to use</tt> </tt>
<a name="L41"></a><tt class="py-lineno"> 41</tt>  <tt class="py-line"><tt class="py-docstring">        :return: str</tt> </tt>
<a name="L42"></a><tt class="py-lineno"> 42</tt>  <tt class="py-line"><tt class="py-docstring">            Url of graph API</tt> </tt>
<a name="L43"></a><tt class="py-lineno"> 43</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L44"></a><tt class="py-lineno"> 44</tt>  <tt class="py-line"> </tt>
<a name="L45"></a><tt class="py-lineno"> 45</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-string">"https://graph.facebook.com/"</tt> <tt class="py-op">+</tt> <tt class="py-string">"v"</tt> <tt class="py-op">+</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">version</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-string">"/"</tt> </tt>
</div><a name="L46"></a><tt class="py-lineno"> 46</tt>  <tt class="py-line"> </tt>
<a name="L47"></a><tt class="py-lineno"> 47</tt>  <tt class="py-line">    <tt class="py-decorator">@</tt><tt class="py-decorator">staticmethod</tt> </tt>
<a name="FacebookGraphApi.parse_api_response"></a><div id="FacebookGraphApi.parse_api_response-def"><a name="L48"></a><tt class="py-lineno"> 48</tt> <a class="py-toggle" href="#" id="FacebookGraphApi.parse_api_response-toggle" onclick="return toggle('FacebookGraphApi.parse_api_response');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookGraphApi-class.html#parse_api_response">parse_api_response</a><tt class="py-op">(</tt><tt class="py-param">url</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookGraphApi.parse_api_response-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookGraphApi.parse_api_response-expanded"><a name="L49"></a><tt class="py-lineno"> 49</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L50"></a><tt class="py-lineno"> 50</tt>  <tt class="py-line"><tt class="py-docstring">        :param url: str</tt> </tt>
<a name="L51"></a><tt class="py-lineno"> 51</tt>  <tt class="py-line"><tt class="py-docstring">            Url to fetch</tt> </tt>
<a name="L52"></a><tt class="py-lineno"> 52</tt>  <tt class="py-line"><tt class="py-docstring">        :return: json loaded</tt> </tt>
<a name="L53"></a><tt class="py-lineno"> 53</tt>  <tt class="py-line"><tt class="py-docstring">            Response json-parsed</tt> </tt>
<a name="L54"></a><tt class="py-lineno"> 54</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L55"></a><tt class="py-lineno"> 55</tt>  <tt class="py-line"> </tt>
<a name="L56"></a><tt class="py-lineno"> 56</tt>  <tt class="py-line">        <tt class="py-name">response</tt> <tt class="py-op">=</tt> <tt class="py-name">requests</tt><tt class="py-op">.</tt><tt class="py-name">get</tt><tt class="py-op">(</tt><tt class="py-name">url</tt><tt class="py-op">)</tt> </tt>
<a name="L57"></a><tt class="py-lineno"> 57</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">json</tt><tt class="py-op">.</tt><tt class="py-name">loads</tt><tt class="py-op">(</tt><tt class="py-name">response</tt><tt class="py-op">.</tt><tt id="link-3" class="py-name" targets="Package pyspottedunipd.text=pyspottedunipd.text-module.html"><a title="pyspottedunipd.text" class="py-name" href="#" onclick="return doclink('link-3', 'text', 'link-3');">text</a></tt><tt class="py-op">)</tt> </tt>
</div><a name="L58"></a><tt class="py-lineno"> 58</tt>  <tt class="py-line"> </tt>
<a name="FacebookGraphApi.get_api_driver"></a><div id="FacebookGraphApi.get_api_driver-def"><a name="L59"></a><tt class="py-lineno"> 59</tt> <a class="py-toggle" href="#" id="FacebookGraphApi.get_api_driver-toggle" onclick="return toggle('FacebookGraphApi.get_api_driver');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookGraphApi-class.html#get_api_driver">get_api_driver</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">version</tt><tt class="py-op">=</tt><tt class="py-string">"2.7"</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookGraphApi.get_api_driver-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookGraphApi.get_api_driver-expanded"><a name="L60"></a><tt class="py-lineno"> 60</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L61"></a><tt class="py-lineno"> 61</tt>  <tt class="py-line"><tt class="py-docstring">        :param version: str</tt> </tt>
<a name="L62"></a><tt class="py-lineno"> 62</tt>  <tt class="py-line"><tt class="py-docstring">            Version of API to use</tt> </tt>
<a name="L63"></a><tt class="py-lineno"> 63</tt>  <tt class="py-line"><tt class="py-docstring">        :return: GraphAPI</tt> </tt>
<a name="L64"></a><tt class="py-lineno"> 64</tt>  <tt class="py-line"><tt class="py-docstring">            Facebook API driver</tt> </tt>
<a name="L65"></a><tt class="py-lineno"> 65</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L66"></a><tt class="py-lineno"> 66</tt>  <tt class="py-line"> </tt>
<a name="L67"></a><tt class="py-lineno"> 67</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">facebook</tt><tt class="py-op">.</tt><tt class="py-name">GraphAPI</tt><tt class="py-op">(</tt><tt class="py-name">access_token</tt><tt class="py-op">=</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">token</tt><tt class="py-op">,</tt> <tt class="py-name">version</tt><tt class="py-op">=</tt><tt class="py-name">version</tt><tt class="py-op">)</tt> </tt>
</div><a name="L68"></a><tt class="py-lineno"> 68</tt>  <tt class="py-line"> </tt>
<a name="FacebookGraphApi.get_page_posts_url"></a><div id="FacebookGraphApi.get_page_posts_url-def"><a name="L69"></a><tt class="py-lineno"> 69</tt> <a class="py-toggle" href="#" id="FacebookGraphApi.get_page_posts_url-toggle" onclick="return toggle('FacebookGraphApi.get_page_posts_url');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookGraphApi-class.html#get_page_posts_url">get_page_posts_url</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">page_id</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookGraphApi.get_page_posts_url-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookGraphApi.get_page_posts_url-expanded"><a name="L70"></a><tt class="py-lineno"> 70</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L71"></a><tt class="py-lineno"> 71</tt>  <tt class="py-line"><tt class="py-docstring">        :param page_id: str</tt> </tt>
<a name="L72"></a><tt class="py-lineno"> 72</tt>  <tt class="py-line"><tt class="py-docstring">            ID of page to scrape</tt> </tt>
<a name="L73"></a><tt class="py-lineno"> 73</tt>  <tt class="py-line"><tt class="py-docstring">        :return: str</tt> </tt>
<a name="L74"></a><tt class="py-lineno"> 74</tt>  <tt class="py-line"><tt class="py-docstring">            Url of posts of page</tt> </tt>
<a name="L75"></a><tt class="py-lineno"> 75</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L76"></a><tt class="py-lineno"> 76</tt>  <tt class="py-line"> </tt>
<a name="L77"></a><tt class="py-lineno"> 77</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-4" class="py-name" targets="Static Method pyspottedunipd.fb.models.FacebookGraphApi.get_api_url()=pyspottedunipd.fb.models.FacebookGraphApi-class.html#get_api_url"><a title="pyspottedunipd.fb.models.FacebookGraphApi.get_api_url" class="py-name" href="#" onclick="return doclink('link-4', 'get_api_url', 'link-4');">get_api_url</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">page_id</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-string">"/posts?limit=100&amp;access_token="</tt> <tt class="py-op">+</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">token</tt> </tt>
</div><a name="L78"></a><tt class="py-lineno"> 78</tt>  <tt class="py-line"> </tt>
<a name="FacebookGraphApi.get_post_summary_urls"></a><div id="FacebookGraphApi.get_post_summary_urls-def"><a name="L79"></a><tt class="py-lineno"> 79</tt> <a class="py-toggle" href="#" id="FacebookGraphApi.get_post_summary_urls-toggle" onclick="return toggle('FacebookGraphApi.get_post_summary_urls');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookGraphApi-class.html#get_post_summary_urls">get_post_summary_urls</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">post_id</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookGraphApi.get_post_summary_urls-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookGraphApi.get_post_summary_urls-expanded"><a name="L80"></a><tt class="py-lineno"> 80</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L81"></a><tt class="py-lineno"> 81</tt>  <tt class="py-line"><tt class="py-docstring">        :param post_id: str</tt> </tt>
<a name="L82"></a><tt class="py-lineno"> 82</tt>  <tt class="py-line"><tt class="py-docstring">            ID if post</tt> </tt>
<a name="L83"></a><tt class="py-lineno"> 83</tt>  <tt class="py-line"><tt class="py-docstring">        :return: {} with keys 'likes', 'comments'</tt> </tt>
<a name="L84"></a><tt class="py-lineno"> 84</tt>  <tt class="py-line"><tt class="py-docstring">            Urls to get info about key</tt> </tt>
<a name="L85"></a><tt class="py-lineno"> 85</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L86"></a><tt class="py-lineno"> 86</tt>  <tt class="py-line"> </tt>
<a name="L87"></a><tt class="py-lineno"> 87</tt>  <tt class="py-line">        <tt class="py-name">likes</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-5" class="py-name"><a title="pyspottedunipd.fb.models.FacebookGraphApi.get_api_url" class="py-name" href="#" onclick="return doclink('link-5', 'get_api_url', 'link-4');">get_api_url</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">post_id</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-string">"/likes?summary=1&amp;access_token="</tt> <tt class="py-op">+</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">token</tt> </tt>
<a name="L88"></a><tt class="py-lineno"> 88</tt>  <tt class="py-line">        <tt class="py-name">comments</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-6" class="py-name"><a title="pyspottedunipd.fb.models.FacebookGraphApi.get_api_url" class="py-name" href="#" onclick="return doclink('link-6', 'get_api_url', 'link-4');">get_api_url</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">post_id</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-string">"/comments?summary=1&amp;access_token="</tt> <tt class="py-op">+</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">token</tt> </tt>
<a name="L89"></a><tt class="py-lineno"> 89</tt>  <tt class="py-line">        <tt class="py-name">shares</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-7" class="py-name"><a title="pyspottedunipd.fb.models.FacebookGraphApi.get_api_url" class="py-name" href="#" onclick="return doclink('link-7', 'get_api_url', 'link-4');">get_api_url</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">post_id</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-string">"?fields=shares&amp;summary=1&amp;access_token="</tt> <tt class="py-op">+</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">token</tt> </tt>
<a name="L90"></a><tt class="py-lineno"> 90</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-op">{</tt> </tt>
<a name="L91"></a><tt class="py-lineno"> 91</tt>  <tt class="py-line">            <tt class="py-string">"likes"</tt><tt class="py-op">:</tt> <tt class="py-name">likes</tt><tt class="py-op">,</tt> </tt>
<a name="L92"></a><tt class="py-lineno"> 92</tt>  <tt class="py-line">            <tt class="py-string">"comments"</tt><tt class="py-op">:</tt> <tt class="py-name">comments</tt><tt class="py-op">,</tt> </tt>
<a name="L93"></a><tt class="py-lineno"> 93</tt>  <tt class="py-line">            <tt class="py-string">"shares"</tt><tt class="py-op">:</tt> <tt class="py-name">shares</tt> </tt>
<a name="L94"></a><tt class="py-lineno"> 94</tt>  <tt class="py-line">        <tt class="py-op">}</tt> </tt>
</div></div><a name="L95"></a><tt class="py-lineno"> 95</tt>  <tt class="py-line"> </tt>
<a name="FacebookBot"></a><div id="FacebookBot-def"><a name="L96"></a><tt class="py-lineno"> 96</tt>  <tt class="py-line"> </tt>
<a name="L97"></a><tt class="py-lineno"> 97</tt> <a class="py-toggle" href="#" id="FacebookBot-toggle" onclick="return toggle('FacebookBot');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookBot-class.html">FacebookBot</a><tt class="py-op">(</tt><tt class="py-base-class">object</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookBot-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="FacebookBot-expanded"><a name="L98"></a><tt class="py-lineno"> 98</tt>  <tt class="py-line">    <tt class="py-docstring">""" A bot that scrapes Facebook with a authentication token """</tt> </tt>
<a name="L99"></a><tt class="py-lineno"> 99</tt>  <tt class="py-line"> </tt>
<a name="FacebookBot.__init__"></a><div id="FacebookBot.__init__-def"><a name="L100"></a><tt class="py-lineno">100</tt> <a class="py-toggle" href="#" id="FacebookBot.__init__-toggle" onclick="return toggle('FacebookBot.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookBot-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">token</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookBot.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookBot.__init__-expanded"><a name="L101"></a><tt class="py-lineno">101</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L102"></a><tt class="py-lineno">102</tt>  <tt class="py-line"><tt class="py-docstring">        :param token: str</tt> </tt>
<a name="L103"></a><tt class="py-lineno">103</tt>  <tt class="py-line"><tt class="py-docstring">            Token to use Facebook API</tt> </tt>
<a name="L104"></a><tt class="py-lineno">104</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L105"></a><tt class="py-lineno">105</tt>  <tt class="py-line"> </tt>
<a name="L106"></a><tt class="py-lineno">106</tt>  <tt class="py-line">        <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-8" class="py-name"><a title="pyspottedunipd.analysis.models.FacebookPostsDataFilter.__init__
pyspottedunipd.analysis.models.MLAnalysis.__init__
pyspottedunipd.analysis.models.StatsAnalysis.__init__
pyspottedunipd.analysis.models.TimeAnalysis.__init__
pyspottedunipd.fb.models.FacebookBot.__init__
pyspottedunipd.fb.models.FacebookGraphApi.__init__
pyspottedunipd.fb.models.FacebookPost.__init__
pyspottedunipd.ngrams.models.Cup.__init__
pyspottedunipd.ngrams.models.Markov.__init__
pyspottedunipd.ngrams.models.NGram.__init__" class="py-name" href="#" onclick="return doclink('link-8', '__init__', 'link-2');">__init__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">)</tt> </tt>
<a name="L107"></a><tt class="py-lineno">107</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">token</tt> <tt class="py-op">=</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">token</tt><tt class="py-op">)</tt> </tt>
<a name="L108"></a><tt class="py-lineno">108</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">api</tt> <tt class="py-op">=</tt> <tt id="link-9" class="py-name" targets="Class pyspottedunipd.fb.models.FacebookGraphApi=pyspottedunipd.fb.models.FacebookGraphApi-class.html"><a title="pyspottedunipd.fb.models.FacebookGraphApi" class="py-name" href="#" onclick="return doclink('link-9', 'FacebookGraphApi', 'link-9');">FacebookGraphApi</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">token</tt><tt class="py-op">)</tt> </tt>
<a name="L109"></a><tt class="py-lineno">109</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">graph</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">api</tt><tt class="py-op">.</tt><tt id="link-10" class="py-name" targets="Method pyspottedunipd.fb.models.FacebookGraphApi.get_api_driver()=pyspottedunipd.fb.models.FacebookGraphApi-class.html#get_api_driver"><a title="pyspottedunipd.fb.models.FacebookGraphApi.get_api_driver" class="py-name" href="#" onclick="return doclink('link-10', 'get_api_driver', 'link-10');">get_api_driver</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
</div><a name="L110"></a><tt class="py-lineno">110</tt>  <tt class="py-line"> </tt>
<a name="FacebookBot.get_latest_posts_of_page"></a><div id="FacebookBot.get_latest_posts_of_page-def"><a name="L111"></a><tt class="py-lineno">111</tt> <a class="py-toggle" href="#" id="FacebookBot.get_latest_posts_of_page-toggle" onclick="return toggle('FacebookBot.get_latest_posts_of_page');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookBot-class.html#get_latest_posts_of_page">get_latest_posts_of_page</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">page_id</tt><tt class="py-op">,</tt> <tt class="py-param">number_to_fetch</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookBot.get_latest_posts_of_page-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookBot.get_latest_posts_of_page-expanded"><a name="L112"></a><tt class="py-lineno">112</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L113"></a><tt class="py-lineno">113</tt>  <tt class="py-line"><tt class="py-docstring">        :param page_id: str</tt> </tt>
<a name="L114"></a><tt class="py-lineno">114</tt>  <tt class="py-line"><tt class="py-docstring">            ID of page to scrape</tt> </tt>
<a name="L115"></a><tt class="py-lineno">115</tt>  <tt class="py-line"><tt class="py-docstring">        :param number_to_fetch: int</tt> </tt>
<a name="L116"></a><tt class="py-lineno">116</tt>  <tt class="py-line"><tt class="py-docstring">            Minimum number of posts to fetch</tt> </tt>
<a name="L117"></a><tt class="py-lineno">117</tt>  <tt class="py-line"><tt class="py-docstring">        :return: [] of str in json format</tt> </tt>
<a name="L118"></a><tt class="py-lineno">118</tt>  <tt class="py-line"><tt class="py-docstring">            Each dict is a raw post (straight out of the API)</tt> </tt>
<a name="L119"></a><tt class="py-lineno">119</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L120"></a><tt class="py-lineno">120</tt>  <tt class="py-line"> </tt>
<a name="L121"></a><tt class="py-lineno">121</tt>  <tt class="py-line">        <tt class="py-name">raw_posts</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-op">]</tt>  <tt class="py-comment"># list of raw fetched posts</tt> </tt>
<a name="L122"></a><tt class="py-lineno">122</tt>  <tt class="py-line">        <tt class="py-name">url</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">api</tt><tt class="py-op">.</tt><tt id="link-11" class="py-name" targets="Method pyspottedunipd.fb.models.FacebookGraphApi.get_page_posts_url()=pyspottedunipd.fb.models.FacebookGraphApi-class.html#get_page_posts_url"><a title="pyspottedunipd.fb.models.FacebookGraphApi.get_page_posts_url" class="py-name" href="#" onclick="return doclink('link-11', 'get_page_posts_url', 'link-11');">get_page_posts_url</a></tt><tt class="py-op">(</tt><tt class="py-name">page_id</tt><tt class="py-op">)</tt>  <tt class="py-comment"># url to get API content</tt> </tt>
<a name="L123"></a><tt class="py-lineno">123</tt>  <tt class="py-line">        <tt class="py-keyword">while</tt> <tt class="py-name">len</tt><tt class="py-op">(</tt><tt class="py-name">raw_posts</tt><tt class="py-op">)</tt> <tt class="py-op">&lt;</tt> <tt class="py-name">number_to_fetch</tt> <tt class="py-keyword">and</tt> <tt class="py-name">url</tt> <tt class="py-keyword">is</tt> <tt class="py-keyword">not</tt> <tt class="py-name">None</tt><tt class="py-op">:</tt> </tt>
<a name="L124"></a><tt class="py-lineno">124</tt>  <tt class="py-line">            <tt class="py-keyword">print</tt><tt class="py-op">(</tt><tt class="py-string">"Fetched"</tt><tt class="py-op">,</tt> <tt class="py-name">len</tt><tt class="py-op">(</tt><tt class="py-name">raw_posts</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> <tt class="py-string">"posts"</tt><tt class="py-op">)</tt>  <tt class="py-comment"># debug info</tt> </tt>
<a name="L125"></a><tt class="py-lineno">125</tt>  <tt class="py-line">            <tt class="py-name">reponse</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">api</tt><tt class="py-op">.</tt><tt id="link-12" class="py-name" targets="Static Method pyspottedunipd.fb.models.FacebookGraphApi.parse_api_response()=pyspottedunipd.fb.models.FacebookGraphApi-class.html#parse_api_response"><a title="pyspottedunipd.fb.models.FacebookGraphApi.parse_api_response" class="py-name" href="#" onclick="return doclink('link-12', 'parse_api_response', 'link-12');">parse_api_response</a></tt><tt class="py-op">(</tt><tt class="py-name">url</tt><tt class="py-op">)</tt>  <tt class="py-comment"># read and parse raw response</tt> </tt>
<a name="L126"></a><tt class="py-lineno">126</tt>  <tt class="py-line"> </tt>
<a name="L127"></a><tt class="py-lineno">127</tt>  <tt class="py-line">            <tt class="py-keyword">try</tt><tt class="py-op">:</tt>  <tt class="py-comment"># parse next url to get posts</tt> </tt>
<a name="L128"></a><tt class="py-lineno">128</tt>  <tt class="py-line">                <tt class="py-name">url</tt> <tt class="py-op">=</tt> <tt class="py-name">reponse</tt><tt class="py-op">[</tt><tt class="py-string">"paging"</tt><tt class="py-op">]</tt><tt class="py-op">[</tt><tt class="py-string">"next"</tt><tt class="py-op">]</tt>  <tt class="py-comment"># url to get next if number of fetched post is not enough</tt> </tt>
<a name="L129"></a><tt class="py-lineno">129</tt>  <tt class="py-line">            <tt class="py-keyword">except</tt><tt class="py-op">:</tt> </tt>
<a name="L130"></a><tt class="py-lineno">130</tt>  <tt class="py-line">                <tt class="py-name">url</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt>  <tt class="py-comment"># no more posts</tt> </tt>
<a name="L131"></a><tt class="py-lineno">131</tt>  <tt class="py-line"> </tt>
<a name="L132"></a><tt class="py-lineno">132</tt>  <tt class="py-line">            <tt class="py-keyword">try</tt><tt class="py-op">:</tt>  <tt class="py-comment"># parse posts data</tt> </tt>
<a name="L133"></a><tt class="py-lineno">133</tt>  <tt class="py-line">                <tt class="py-name">data</tt> <tt class="py-op">=</tt> <tt class="py-name">reponse</tt><tt class="py-op">[</tt><tt class="py-string">"data"</tt><tt class="py-op">]</tt>  <tt class="py-comment"># real data in response</tt> </tt>
<a name="L134"></a><tt class="py-lineno">134</tt>  <tt class="py-line">            <tt class="py-keyword">except</tt><tt class="py-op">:</tt> </tt>
<a name="L135"></a><tt class="py-lineno">135</tt>  <tt class="py-line">                <tt class="py-name">data</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-op">]</tt>  <tt class="py-comment"># no more posts</tt> </tt>
<a name="L136"></a><tt class="py-lineno">136</tt>  <tt class="py-line"> </tt>
<a name="L137"></a><tt class="py-lineno">137</tt>  <tt class="py-line">            <tt class="py-name">raw_posts</tt> <tt class="py-op">+=</tt> <tt class="py-name">data</tt> </tt>
<a name="L138"></a><tt class="py-lineno">138</tt>  <tt class="py-line"> </tt>
<a name="L139"></a><tt class="py-lineno">139</tt>  <tt class="py-line">        <tt class="py-name">raw_posts</tt> <tt class="py-op">=</tt> <tt class="py-name">raw_posts</tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-name">number_to_fetch</tt><tt class="py-op">]</tt>  <tt class="py-comment"># take exact number</tt> </tt>
<a name="L140"></a><tt class="py-lineno">140</tt>  <tt class="py-line">        <tt class="py-name">posts</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-op">]</tt>  <tt class="py-comment"># list of parsed posts</tt> </tt>
<a name="L141"></a><tt class="py-lineno">141</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">raw_post</tt> <tt class="py-keyword">in</tt> <tt class="py-name">raw_posts</tt><tt class="py-op">:</tt> </tt>
<a name="L142"></a><tt class="py-lineno">142</tt>  <tt class="py-line">            <tt class="py-name">p</tt> <tt class="py-op">=</tt> <tt id="link-13" class="py-name" targets="Class pyspottedunipd.fb.models.FacebookPost=pyspottedunipd.fb.models.FacebookPost-class.html"><a title="pyspottedunipd.fb.models.FacebookPost" class="py-name" href="#" onclick="return doclink('link-13', 'FacebookPost', 'link-13');">FacebookPost</a></tt><tt class="py-op">(</tt><tt class="py-name">raw_post</tt><tt class="py-op">)</tt>  <tt class="py-comment"># parse post</tt> </tt>
<a name="L143"></a><tt class="py-lineno">143</tt>  <tt class="py-line">            <tt class="py-keyword">print</tt><tt class="py-op">(</tt><tt class="py-string">"Parsing"</tt><tt class="py-op">,</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">len</tt><tt class="py-op">(</tt><tt class="py-name">posts</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> <tt class="py-op">+</tt> <tt class="py-string">"-th Facebook post"</tt><tt class="py-op">,</tt> <tt class="py-name">p</tt><tt class="py-op">.</tt><tt class="py-name">facebook_id</tt><tt class="py-op">)</tt>  <tt class="py-comment"># debug info</tt> </tt>
<a name="L144"></a><tt class="py-lineno">144</tt>  <tt class="py-line">            <tt class="py-name">p</tt><tt class="py-op">.</tt><tt id="link-14" class="py-name" targets="Method pyspottedunipd.fb.models.FacebookPost.get_totals()=pyspottedunipd.fb.models.FacebookPost-class.html#get_totals"><a title="pyspottedunipd.fb.models.FacebookPost.get_totals" class="py-name" href="#" onclick="return doclink('link-14', 'get_totals', 'link-14');">get_totals</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">api</tt><tt class="py-op">)</tt>  <tt class="py-comment"># get likes and comments count</tt> </tt>
<a name="L145"></a><tt class="py-lineno">145</tt>  <tt class="py-line">            <tt class="py-name">posts</tt><tt class="py-op">.</tt><tt class="py-name">append</tt><tt class="py-op">(</tt><tt class="py-name">p</tt><tt class="py-op">)</tt>  <tt class="py-comment"># append to parsed list</tt> </tt>
<a name="L146"></a><tt class="py-lineno">146</tt>  <tt class="py-line"> </tt>
<a name="L147"></a><tt class="py-lineno">147</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">posts</tt> </tt>
</div><a name="L148"></a><tt class="py-lineno">148</tt>  <tt class="py-line"> </tt>
<a name="FacebookBot.download_page_posts"></a><div id="FacebookBot.download_page_posts-def"><a name="L149"></a><tt class="py-lineno">149</tt> <a class="py-toggle" href="#" id="FacebookBot.download_page_posts-toggle" onclick="return toggle('FacebookBot.download_page_posts');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookBot-class.html#download_page_posts">download_page_posts</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">page_id</tt><tt class="py-op">,</tt> <tt class="py-param">min_number_to_fetch</tt><tt class="py-op">,</tt> <tt class="py-param">output_file</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookBot.download_page_posts-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookBot.download_page_posts-expanded"><a name="L150"></a><tt class="py-lineno">150</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L151"></a><tt class="py-lineno">151</tt>  <tt class="py-line"><tt class="py-docstring">        :param page_id: str</tt> </tt>
<a name="L152"></a><tt class="py-lineno">152</tt>  <tt class="py-line"><tt class="py-docstring">            ID of page to scrape</tt> </tt>
<a name="L153"></a><tt class="py-lineno">153</tt>  <tt class="py-line"><tt class="py-docstring">        :param min_number_to_fetch: int</tt> </tt>
<a name="L154"></a><tt class="py-lineno">154</tt>  <tt class="py-line"><tt class="py-docstring">            Minimum number of posts to fetch</tt> </tt>
<a name="L155"></a><tt class="py-lineno">155</tt>  <tt class="py-line"><tt class="py-docstring">        :param output_file: str</tt> </tt>
<a name="L156"></a><tt class="py-lineno">156</tt>  <tt class="py-line"><tt class="py-docstring">            Path to output file to write data</tt> </tt>
<a name="L157"></a><tt class="py-lineno">157</tt>  <tt class="py-line"><tt class="py-docstring">        :return: void</tt> </tt>
<a name="L158"></a><tt class="py-lineno">158</tt>  <tt class="py-line"><tt class="py-docstring">            Saves .csv file with posts data</tt> </tt>
<a name="L159"></a><tt class="py-lineno">159</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L160"></a><tt class="py-lineno">160</tt>  <tt class="py-line"> </tt>
<a name="L161"></a><tt class="py-lineno">161</tt>  <tt class="py-line">        <tt class="py-name">posts</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-15" class="py-name" targets="Method pyspottedunipd.fb.models.FacebookBot.get_latest_posts_of_page()=pyspottedunipd.fb.models.FacebookBot-class.html#get_latest_posts_of_page"><a title="pyspottedunipd.fb.models.FacebookBot.get_latest_posts_of_page" class="py-name" href="#" onclick="return doclink('link-15', 'get_latest_posts_of_page', 'link-15');">get_latest_posts_of_page</a></tt><tt class="py-op">(</tt><tt class="py-name">page_id</tt><tt class="py-op">,</tt> <tt class="py-name">min_number_to_fetch</tt><tt class="py-op">)</tt> </tt>
<a name="L162"></a><tt class="py-lineno">162</tt>  <tt class="py-line">        <tt class="py-name">dicts</tt> <tt class="py-op">=</tt> <tt class="py-op">[</tt><tt class="py-name">p</tt><tt class="py-op">.</tt><tt id="link-16" class="py-name" targets="Method pyspottedunipd.fb.models.FacebookPost.to_dict()=pyspottedunipd.fb.models.FacebookPost-class.html#to_dict"><a title="pyspottedunipd.fb.models.FacebookPost.to_dict" class="py-name" href="#" onclick="return doclink('link-16', 'to_dict', 'link-16');">to_dict</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> <tt class="py-keyword">for</tt> <tt class="py-name">p</tt> <tt class="py-keyword">in</tt> <tt class="py-name">posts</tt><tt class="py-op">]</tt>  <tt class="py-comment"># get dictionaries</tt> </tt>
<a name="L163"></a><tt class="py-lineno">163</tt>  <tt class="py-line">        <tt id="link-17" class="py-name"><a title="pyspottedunipd.utils" class="py-name" href="#" onclick="return doclink('link-17', 'utils', 'link-1');">utils</a></tt><tt class="py-op">.</tt><tt id="link-18" class="py-name" targets="Function pyspottedunipd.utils.save_dicts_to_csv()=pyspottedunipd.utils-module.html#save_dicts_to_csv"><a title="pyspottedunipd.utils.save_dicts_to_csv" class="py-name" href="#" onclick="return doclink('link-18', 'save_dicts_to_csv', 'link-18');">save_dicts_to_csv</a></tt><tt class="py-op">(</tt> </tt>
<a name="L164"></a><tt class="py-lineno">164</tt>  <tt class="py-line">            <tt class="py-name">dicts</tt><tt class="py-op">,</tt> </tt>
<a name="L165"></a><tt class="py-lineno">165</tt>  <tt class="py-line">            <tt class="py-name">output_file</tt> </tt>
<a name="L166"></a><tt class="py-lineno">166</tt>  <tt class="py-line">        <tt class="py-op">)</tt>  <tt class="py-comment"># save to .csv</tt> </tt>
</div></div><a name="L167"></a><tt class="py-lineno">167</tt>  <tt class="py-line"> </tt>
<a name="FacebookPost"></a><div id="FacebookPost-def"><a name="L168"></a><tt class="py-lineno">168</tt>  <tt class="py-line"> </tt>
<a name="L169"></a><tt class="py-lineno">169</tt> <a class="py-toggle" href="#" id="FacebookPost-toggle" onclick="return toggle('FacebookPost');">-</a><tt class="py-line"><tt class="py-keyword">class</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookPost-class.html">FacebookPost</a><tt class="py-op">(</tt><tt class="py-base-class">object</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookPost-collapsed" style="display:none;" pad="+++" indent="++++"></div><div id="FacebookPost-expanded"><a name="L170"></a><tt class="py-lineno">170</tt>  <tt class="py-line">    <tt class="py-docstring">""" A standard Facebook post """</tt> </tt>
<a name="L171"></a><tt class="py-lineno">171</tt>  <tt class="py-line"> </tt>
<a name="FacebookPost.__init__"></a><div id="FacebookPost.__init__-def"><a name="L172"></a><tt class="py-lineno">172</tt> <a class="py-toggle" href="#" id="FacebookPost.__init__-toggle" onclick="return toggle('FacebookPost.__init__');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookPost-class.html#__init__">__init__</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">raw_json_api_response</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookPost.__init__-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookPost.__init__-expanded"><a name="L173"></a><tt class="py-lineno">173</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L174"></a><tt class="py-lineno">174</tt>  <tt class="py-line"><tt class="py-docstring">        :param raw_json_api_response: str in json format</tt> </tt>
<a name="L175"></a><tt class="py-lineno">175</tt>  <tt class="py-line"><tt class="py-docstring">            Standard format coming out of the official API</tt> </tt>
<a name="L176"></a><tt class="py-lineno">176</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L177"></a><tt class="py-lineno">177</tt>  <tt class="py-line"> </tt>
<a name="L178"></a><tt class="py-lineno">178</tt>  <tt class="py-line">        <tt class="py-name">object</tt><tt class="py-op">.</tt><tt id="link-19" class="py-name"><a title="pyspottedunipd.analysis.models.FacebookPostsDataFilter.__init__
pyspottedunipd.analysis.models.MLAnalysis.__init__
pyspottedunipd.analysis.models.StatsAnalysis.__init__
pyspottedunipd.analysis.models.TimeAnalysis.__init__
pyspottedunipd.fb.models.FacebookBot.__init__
pyspottedunipd.fb.models.FacebookGraphApi.__init__
pyspottedunipd.fb.models.FacebookPost.__init__
pyspottedunipd.ngrams.models.Cup.__init__
pyspottedunipd.ngrams.models.Markov.__init__
pyspottedunipd.ngrams.models.NGram.__init__" class="py-name" href="#" onclick="return doclink('link-19', '__init__', 'link-2');">__init__</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">)</tt> </tt>
<a name="L179"></a><tt class="py-lineno">179</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">raw_json</tt> <tt class="py-op">=</tt> <tt class="py-name">raw_json_api_response</tt> </tt>
<a name="L180"></a><tt class="py-lineno">180</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">message</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L181"></a><tt class="py-lineno">181</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">time</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L182"></a><tt class="py-lineno">182</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">date</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L183"></a><tt class="py-lineno">183</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">facebook_id</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L184"></a><tt class="py-lineno">184</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">likes_count</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L185"></a><tt class="py-lineno">185</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">comments_count</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L186"></a><tt class="py-lineno">186</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">shares_count</tt> <tt class="py-op">=</tt> <tt class="py-name">None</tt> </tt>
<a name="L187"></a><tt class="py-lineno">187</tt>  <tt class="py-line"> </tt>
<a name="L188"></a><tt class="py-lineno">188</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-20" class="py-name" targets="Method pyspottedunipd.fb.models.FacebookPost.parse()=pyspottedunipd.fb.models.FacebookPost-class.html#parse"><a title="pyspottedunipd.fb.models.FacebookPost.parse" class="py-name" href="#" onclick="return doclink('link-20', 'parse', 'link-20');">parse</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt>  <tt class="py-comment"># parse raw json</tt> </tt>
</div><a name="L189"></a><tt class="py-lineno">189</tt>  <tt class="py-line"> </tt>
<a name="FacebookPost.parse"></a><div id="FacebookPost.parse-def"><a name="L190"></a><tt class="py-lineno">190</tt> <a class="py-toggle" href="#" id="FacebookPost.parse-toggle" onclick="return toggle('FacebookPost.parse');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookPost-class.html#parse">parse</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookPost.parse-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookPost.parse-expanded"><a name="L191"></a><tt class="py-lineno">191</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L192"></a><tt class="py-lineno">192</tt>  <tt class="py-line"><tt class="py-docstring">        :return: void</tt> </tt>
<a name="L193"></a><tt class="py-lineno">193</tt>  <tt class="py-line"><tt class="py-docstring">            Parses raw json response of API and set object's fields</tt> </tt>
<a name="L194"></a><tt class="py-lineno">194</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L195"></a><tt class="py-lineno">195</tt>  <tt class="py-line"> </tt>
<a name="L196"></a><tt class="py-lineno">196</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L197"></a><tt class="py-lineno">197</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">message</tt> <tt class="py-op">=</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">raw_json</tt><tt class="py-op">[</tt><tt class="py-string">"message"</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L198"></a><tt class="py-lineno">198</tt>  <tt class="py-line">        <tt class="py-keyword">except</tt><tt class="py-op">:</tt> </tt>
<a name="L199"></a><tt class="py-lineno">199</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">message</tt> <tt class="py-op">=</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">raw_json</tt><tt class="py-op">[</tt><tt class="py-string">"story"</tt><tt class="py-op">]</tt><tt class="py-op">)</tt>  <tt class="py-comment"># in case of a picture</tt> </tt>
<a name="L200"></a><tt class="py-lineno">200</tt>  <tt class="py-line"> </tt>
<a name="L201"></a><tt class="py-lineno">201</tt>  <tt class="py-line">        <tt class="py-name">raw_time</tt> <tt class="py-op">=</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">raw_json</tt><tt class="py-op">[</tt><tt class="py-string">"created_time"</tt><tt class="py-op">]</tt><tt class="py-op">)</tt><tt class="py-op">.</tt><tt class="py-name">split</tt><tt class="py-op">(</tt><tt class="py-string">"+"</tt><tt class="py-op">)</tt><tt class="py-op">[</tt><tt class="py-number">0</tt><tt class="py-op">]</tt>  <tt class="py-comment"># discard +0000 (CET)</tt> </tt>
<a name="L202"></a><tt class="py-lineno">202</tt>  <tt class="py-line">        <tt class="py-name">raw_time</tt> <tt class="py-op">=</tt> <tt class="py-name">datetime</tt><tt class="py-op">.</tt><tt class="py-name">datetime</tt><tt class="py-op">.</tt><tt class="py-name">strptime</tt><tt class="py-op">(</tt><tt class="py-name">raw_time</tt><tt class="py-op">,</tt> <tt class="py-string">"%Y-%m-%dT%H:%M:%S"</tt><tt class="py-op">)</tt>  <tt class="py-comment"># parse time to get datetime</tt> </tt>
<a name="L203"></a><tt class="py-lineno">203</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">time</tt> <tt class="py-op">=</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">raw_time</tt><tt class="py-op">.</tt><tt class="py-name">time</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L204"></a><tt class="py-lineno">204</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">date</tt> <tt class="py-op">=</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">raw_time</tt><tt class="py-op">.</tt><tt class="py-name">date</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">)</tt> </tt>
<a name="L205"></a><tt class="py-lineno">205</tt>  <tt class="py-line"> </tt>
<a name="L206"></a><tt class="py-lineno">206</tt>  <tt class="py-line">        <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">facebook_id</tt> <tt class="py-op">=</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">raw_json</tt><tt class="py-op">[</tt><tt class="py-string">"id"</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
</div><a name="L207"></a><tt class="py-lineno">207</tt>  <tt class="py-line"> </tt>
<a name="FacebookPost.get_totals"></a><div id="FacebookPost.get_totals-def"><a name="L208"></a><tt class="py-lineno">208</tt> <a class="py-toggle" href="#" id="FacebookPost.get_totals-toggle" onclick="return toggle('FacebookPost.get_totals');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookPost-class.html#get_totals">get_totals</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">,</tt> <tt class="py-param">api_driver</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookPost.get_totals-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookPost.get_totals-expanded"><a name="L209"></a><tt class="py-lineno">209</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L210"></a><tt class="py-lineno">210</tt>  <tt class="py-line"><tt class="py-docstring">        :param api_driver: FacebookGraphApi</tt> </tt>
<a name="L211"></a><tt class="py-lineno">211</tt>  <tt class="py-line"><tt class="py-docstring">            API driver to use</tt> </tt>
<a name="L212"></a><tt class="py-lineno">212</tt>  <tt class="py-line"><tt class="py-docstring">        :return: void</tt> </tt>
<a name="L213"></a><tt class="py-lineno">213</tt>  <tt class="py-line"><tt class="py-docstring">            Gets counts of likes and comments</tt> </tt>
<a name="L214"></a><tt class="py-lineno">214</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L215"></a><tt class="py-lineno">215</tt>  <tt class="py-line"> </tt>
<a name="L216"></a><tt class="py-lineno">216</tt>  <tt class="py-line">        <tt class="py-name">urls</tt> <tt class="py-op">=</tt> <tt class="py-name">api_driver</tt><tt class="py-op">.</tt><tt id="link-21" class="py-name" targets="Method pyspottedunipd.fb.models.FacebookGraphApi.get_post_summary_urls()=pyspottedunipd.fb.models.FacebookGraphApi-class.html#get_post_summary_urls"><a title="pyspottedunipd.fb.models.FacebookGraphApi.get_post_summary_urls" class="py-name" href="#" onclick="return doclink('link-21', 'get_post_summary_urls', 'link-21');">get_post_summary_urls</a></tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">facebook_id</tt><tt class="py-op">)</tt>  <tt class="py-comment"># get likes and comments urls</tt> </tt>
<a name="L217"></a><tt class="py-lineno">217</tt>  <tt class="py-line">        <tt class="py-name">raw_likes_data</tt> <tt class="py-op">=</tt> <tt class="py-name">api_driver</tt><tt class="py-op">.</tt><tt id="link-22" class="py-name"><a title="pyspottedunipd.fb.models.FacebookGraphApi.parse_api_response" class="py-name" href="#" onclick="return doclink('link-22', 'parse_api_response', 'link-12');">parse_api_response</a></tt><tt class="py-op">(</tt><tt class="py-name">urls</tt><tt class="py-op">[</tt><tt class="py-string">"likes"</tt><tt class="py-op">]</tt><tt class="py-op">)</tt>  <tt class="py-comment"># get raw data</tt> </tt>
<a name="L218"></a><tt class="py-lineno">218</tt>  <tt class="py-line">        <tt class="py-name">raw_comments_data</tt> <tt class="py-op">=</tt> <tt class="py-name">api_driver</tt><tt class="py-op">.</tt><tt id="link-23" class="py-name"><a title="pyspottedunipd.fb.models.FacebookGraphApi.parse_api_response" class="py-name" href="#" onclick="return doclink('link-23', 'parse_api_response', 'link-12');">parse_api_response</a></tt><tt class="py-op">(</tt><tt class="py-name">urls</tt><tt class="py-op">[</tt><tt class="py-string">"comments"</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L219"></a><tt class="py-lineno">219</tt>  <tt class="py-line">        <tt class="py-name">raw_shares_data</tt> <tt class="py-op">=</tt> <tt class="py-name">api_driver</tt><tt class="py-op">.</tt><tt id="link-24" class="py-name"><a title="pyspottedunipd.fb.models.FacebookGraphApi.parse_api_response" class="py-name" href="#" onclick="return doclink('link-24', 'parse_api_response', 'link-12');">parse_api_response</a></tt><tt class="py-op">(</tt><tt class="py-name">urls</tt><tt class="py-op">[</tt><tt class="py-string">"shares"</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L220"></a><tt class="py-lineno">220</tt>  <tt class="py-line"> </tt>
<a name="L221"></a><tt class="py-lineno">221</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt>  <tt class="py-comment"># parse raw data</tt> </tt>
<a name="L222"></a><tt class="py-lineno">222</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">likes_count</tt> <tt class="py-op">=</tt> <tt class="py-name">float</tt><tt class="py-op">(</tt><tt class="py-name">raw_likes_data</tt><tt class="py-op">[</tt><tt class="py-string">"summary"</tt><tt class="py-op">]</tt><tt class="py-op">[</tt><tt class="py-string">"total_count"</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L223"></a><tt class="py-lineno">223</tt>  <tt class="py-line">        <tt class="py-keyword">except</tt><tt class="py-op">:</tt> </tt>
<a name="L224"></a><tt class="py-lineno">224</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">likes_count</tt> <tt class="py-op">=</tt> <tt class="py-number">0</tt> </tt>
<a name="L225"></a><tt class="py-lineno">225</tt>  <tt class="py-line"> </tt>
<a name="L226"></a><tt class="py-lineno">226</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L227"></a><tt class="py-lineno">227</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">comments_count</tt> <tt class="py-op">=</tt> <tt class="py-name">float</tt><tt class="py-op">(</tt><tt class="py-name">raw_comments_data</tt><tt class="py-op">[</tt><tt class="py-string">"summary"</tt><tt class="py-op">]</tt><tt class="py-op">[</tt><tt class="py-string">"total_count"</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L228"></a><tt class="py-lineno">228</tt>  <tt class="py-line">        <tt class="py-keyword">except</tt><tt class="py-op">:</tt> </tt>
<a name="L229"></a><tt class="py-lineno">229</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">comments_count</tt> <tt class="py-op">=</tt> <tt class="py-number">0</tt> </tt>
<a name="L230"></a><tt class="py-lineno">230</tt>  <tt class="py-line"> </tt>
<a name="L231"></a><tt class="py-lineno">231</tt>  <tt class="py-line">        <tt class="py-keyword">try</tt><tt class="py-op">:</tt> </tt>
<a name="L232"></a><tt class="py-lineno">232</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">shares_count</tt> <tt class="py-op">=</tt> <tt class="py-name">float</tt><tt class="py-op">(</tt><tt class="py-name">raw_shares_data</tt><tt class="py-op">[</tt><tt class="py-string">"shares"</tt><tt class="py-op">]</tt><tt class="py-op">[</tt><tt class="py-string">"count"</tt><tt class="py-op">]</tt><tt class="py-op">)</tt> </tt>
<a name="L233"></a><tt class="py-lineno">233</tt>  <tt class="py-line">        <tt class="py-keyword">except</tt><tt class="py-op">:</tt> </tt>
<a name="L234"></a><tt class="py-lineno">234</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">shares_count</tt> <tt class="py-op">=</tt> <tt class="py-number">0</tt> </tt>
<a name="L235"></a><tt class="py-lineno">235</tt>  <tt class="py-line"> </tt>
<a name="L236"></a><tt class="py-lineno">236</tt>  <tt class="py-line">        <tt class="py-keyword">print</tt><tt class="py-op">(</tt> </tt>
<a name="L237"></a><tt class="py-lineno">237</tt>  <tt class="py-line">            <tt class="py-string">"\tParsing post"</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">message</tt><tt class="py-op">[</tt><tt class="py-op">:</tt><tt class="py-number">16</tt><tt class="py-op">]</tt><tt class="py-op">,</tt> <tt class="py-string">"("</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">facebook_id</tt><tt class="py-op">,</tt> <tt class="py-string">")"</tt><tt class="py-op">,</tt> </tt>
<a name="L238"></a><tt class="py-lineno">238</tt>  <tt class="py-line">            <tt class="py-string">"at"</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">time</tt><tt class="py-op">,</tt> <tt class="py-string">"on"</tt><tt class="py-op">,</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">date</tt><tt class="py-op">,</tt> </tt>
<a name="L239"></a><tt class="py-lineno">239</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">likes_count</tt><tt class="py-op">,</tt> <tt class="py-string">"***  "</tt><tt class="py-op">,</tt> </tt>
<a name="L240"></a><tt class="py-lineno">240</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">comments_count</tt><tt class="py-op">,</tt> <tt class="py-string">"-.-  "</tt><tt class="py-op">,</tt> </tt>
<a name="L241"></a><tt class="py-lineno">241</tt>  <tt class="py-line">            <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">shares_count</tt><tt class="py-op">,</tt> <tt class="py-string">"|-"</tt> </tt>
<a name="L242"></a><tt class="py-lineno">242</tt>  <tt class="py-line">        <tt class="py-op">)</tt>  <tt class="py-comment"># debug info</tt> </tt>
</div><a name="L243"></a><tt class="py-lineno">243</tt>  <tt class="py-line"> </tt>
<a name="FacebookPost.to_dict"></a><div id="FacebookPost.to_dict-def"><a name="L244"></a><tt class="py-lineno">244</tt> <a class="py-toggle" href="#" id="FacebookPost.to_dict-toggle" onclick="return toggle('FacebookPost.to_dict');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookPost-class.html#to_dict">to_dict</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookPost.to_dict-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookPost.to_dict-expanded"><a name="L245"></a><tt class="py-lineno">245</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L246"></a><tt class="py-lineno">246</tt>  <tt class="py-line"><tt class="py-docstring">        :return: dict</tt> </tt>
<a name="L247"></a><tt class="py-lineno">247</tt>  <tt class="py-line"><tt class="py-docstring">            Dictionary with keys (obj fields) and values (obj values)</tt> </tt>
<a name="L248"></a><tt class="py-lineno">248</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L249"></a><tt class="py-lineno">249</tt>  <tt class="py-line"> </tt>
<a name="L250"></a><tt class="py-lineno">250</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-op">{</tt> </tt>
<a name="L251"></a><tt class="py-lineno">251</tt>  <tt class="py-line">            <tt class="py-string">"message"</tt><tt class="py-op">:</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">message</tt><tt class="py-op">,</tt> </tt>
<a name="L252"></a><tt class="py-lineno">252</tt>  <tt class="py-line">            <tt class="py-string">"time"</tt><tt class="py-op">:</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">time</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L253"></a><tt class="py-lineno">253</tt>  <tt class="py-line">            <tt class="py-string">"date"</tt><tt class="py-op">:</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">date</tt><tt class="py-op">)</tt><tt class="py-op">,</tt> </tt>
<a name="L254"></a><tt class="py-lineno">254</tt>  <tt class="py-line">            <tt class="py-string">"id"</tt><tt class="py-op">:</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">facebook_id</tt><tt class="py-op">,</tt> </tt>
<a name="L255"></a><tt class="py-lineno">255</tt>  <tt class="py-line">            <tt class="py-string">"likes"</tt><tt class="py-op">:</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">likes_count</tt><tt class="py-op">,</tt> </tt>
<a name="L256"></a><tt class="py-lineno">256</tt>  <tt class="py-line">            <tt class="py-string">"comments"</tt><tt class="py-op">:</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">comments_count</tt><tt class="py-op">,</tt> </tt>
<a name="L257"></a><tt class="py-lineno">257</tt>  <tt class="py-line">            <tt class="py-string">"shares"</tt><tt class="py-op">:</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt class="py-name">shares_count</tt> </tt>
<a name="L258"></a><tt class="py-lineno">258</tt>  <tt class="py-line">        <tt class="py-op">}</tt> </tt>
</div><a name="L259"></a><tt class="py-lineno">259</tt>  <tt class="py-line"> </tt>
<a name="FacebookPost.to_json"></a><div id="FacebookPost.to_json-def"><a name="L260"></a><tt class="py-lineno">260</tt> <a class="py-toggle" href="#" id="FacebookPost.to_json-toggle" onclick="return toggle('FacebookPost.to_json');">-</a><tt class="py-line">    <tt class="py-keyword">def</tt> <a class="py-def-name" href="pyspottedunipd.fb.models.FacebookPost-class.html#to_json">to_json</a><tt class="py-op">(</tt><tt class="py-param">self</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
</div><div id="FacebookPost.to_json-collapsed" style="display:none;" pad="+++" indent="++++++++"></div><div id="FacebookPost.to_json-expanded"><a name="L261"></a><tt class="py-lineno">261</tt>  <tt class="py-line">        <tt class="py-docstring">"""</tt> </tt>
<a name="L262"></a><tt class="py-lineno">262</tt>  <tt class="py-line"><tt class="py-docstring">        :return: json object</tt> </tt>
<a name="L263"></a><tt class="py-lineno">263</tt>  <tt class="py-line"><tt class="py-docstring">            A json representation of this object</tt> </tt>
<a name="L264"></a><tt class="py-lineno">264</tt>  <tt class="py-line"><tt class="py-docstring">        """</tt> </tt>
<a name="L265"></a><tt class="py-lineno">265</tt>  <tt class="py-line"> </tt>
<a name="L266"></a><tt class="py-lineno">266</tt>  <tt class="py-line">        <tt class="py-name">d</tt> <tt class="py-op">=</tt> <tt class="py-name">self</tt><tt class="py-op">.</tt><tt id="link-25" class="py-name"><a title="pyspottedunipd.fb.models.FacebookPost.to_dict" class="py-name" href="#" onclick="return doclink('link-25', 'to_dict', 'link-16');">to_dict</a></tt><tt class="py-op">(</tt><tt class="py-op">)</tt> </tt>
<a name="L267"></a><tt class="py-lineno">267</tt>  <tt class="py-line">        <tt class="py-keyword">for</tt> <tt class="py-name">k</tt> <tt class="py-keyword">in</tt> <tt class="py-name">d</tt><tt class="py-op">.</tt><tt class="py-name">keys</tt><tt class="py-op">(</tt><tt class="py-op">)</tt><tt class="py-op">:</tt> </tt>
<a name="L268"></a><tt class="py-lineno">268</tt>  <tt class="py-line">            <tt class="py-name">d</tt><tt class="py-op">[</tt><tt class="py-name">k</tt><tt class="py-op">]</tt> <tt class="py-op">=</tt> <tt class="py-name">str</tt><tt class="py-op">(</tt><tt class="py-name">d</tt><tt class="py-op">[</tt><tt class="py-name">k</tt><tt class="py-op">]</tt><tt class="py-op">)</tt>  <tt class="py-comment"># convert to string to be json serializable</tt> </tt>
<a name="L269"></a><tt class="py-lineno">269</tt>  <tt class="py-line"> </tt>
<a name="L270"></a><tt class="py-lineno">270</tt>  <tt class="py-line">        <tt class="py-keyword">return</tt> <tt class="py-name">json</tt><tt class="py-op">.</tt><tt class="py-name">dumps</tt><tt class="py-op">(</tt><tt class="py-name">d</tt><tt class="py-op">)</tt> </tt>
</div></div><a name="L271"></a><tt class="py-lineno">271</tt>  <tt class="py-line"> </tt><script type="text/javascript">
<!--
expandto(location.href);
// -->
</script>
</pre>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a href="https://github.com/sirfoga/spotted-unipd">PySpottedUnipd</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Thu Apr 20 22:50:23 2017
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
